Integrations / React Integration

React Integration

The jsPlumb Toolkit has several components to assist you to integrate with React. This page provides an overview.

Note The original React integration was moved to the jsplumbtoolkit-react-legacy.tgz package as of 2.3.0. It is now deprecated and will be removed in 2.4.0. For existing users of the Toolkit upgrading to version 2.3.0, see this page if you'd just like to switch your imports to the legacy integration and make no other change.

The fundamental difference between the legacy React integration and the current React integration is in the fact that the legacy integration does not render node/group components as children of the Surface component, but the current integration does. This has two main ramifications:

  • You can now pass props down to node/group components
  • Event binding works from 17.x onwards with the current integration.

The first of these - passing props to node/group components - is not something that every application needs, but which can be useful: you can change the appearance of your elements without also having to manipulate the underlying Toolkit's data model. We've incorporated an example of this in the React Skeleton demonstration. The second of these is slightly more fundamental, and is caused by a change React made in 17.x: the element which the delegated event listener is attached used to be the document, and now its the root element into which the given React tree was rendered. As node/group components are not rendered in the tree by the legacy integration, event bindings on them do not work in 17.x.

Other changes made in 2.3.0 include:

  • the ability to specify arbitrary JSX for some node/group, rather than just a component class reference.

The React integration ships in a separate tar - jsplumbtoolkit-react.tgz. Add it to your package.json alongside the Toolkit dependency declaration:

 {
    ...
    "dependencies":{
        ...
        "jsplumbtoolkit":"file:path/to/jsplumbtoolkit.tgz",
        "jsplumbtoolkit-react":"file:path/to/jsplumbtoolkit-react.tgz"
        ...
    }
    ...
}

TOP


The main component you will use is the JsPlumbToolkitSurfaceComponent.

Let's take a quick look at how you'd use one:

class DemoComponent extends React.Component {

    constructor(props) {
        super(props);
        this.toolkit = jsPlumbToolkit.newInstance({
            ...
        });

        this.view = {
            ...
        }

        this.renderParams = {
            ...
        }
    }

    render() {
        return <div style={{width:"100%",height:"100%"}}>
                    <JsPlumbToolkitSurfaceComponent renderParams={this.renderParams} toolkit={this.toolkit} view={this.view} ref={ (c) => { if (c != null) this.surface = c.surface } }/>
                    <ControlsComponent ref={(c) => this.controls = c }/>
                    <DatasetComponent ref={(d) => this.dataset = d }/>
                    <div className="miniview"/>                        
                </div>
    }
        
}

We create an instance of the Toolkit in the component's constructor, which we then inject into the JsPlumbToolkitSurfaceComponent, along with renderParams and the view.

ControlsComponent is something built for the Toolkit React demonstrations, to handle zoom/selection of nodes. DatasetComponent is also part of this demonstration - it's a React version of the dataset view you may have seen on other demonstrations. Neither of these components ships in the React integration package, but you are welcome to grab the code from one of the demonstrations if you wish to use it.

jsPlumb Components

React is component based. The Toolkit offers 3 components:

JsPlumbToolkitSurfaceComponent

<JsPlumbToolkitSurfaceComponent renderParams={this.renderParams} view={this.view} toolkit={this.toolkit}/>
Attributes
  • toolkit A reference to an instance of the Toolkit. Required.
  • renderParams Parameters to pass in to the constructor of the Surface widget. Optional, but you'll probably supply something here.
  • view View parameters. Views are discussed here. Again, optional, but you'll probably want to supply something.

TOP


JsPlumbToolkitMiniviewComponent

Provides a Miniview that can be attached to some Surface component.

Example

import JsPlumbToolkitMiniviewComponent from 'jsplumbtoolkit-react';

const miniview = ReactDOM.render(
    <JsPlumbToolkitMiniviewComponent surface={JsPlumbToolkitSurfaceComponent}/>, document.querySelector(".miniview")
)
Attributes
  • surface The JsPlumbToolkitSurfaceComponent to which to attach the Miniview component.

TOP


SurfaceDropComponent

Provides a means to implement drag/drop of new Nodes/Groups onto your Surface. This component is abstract; you are expected to provide the render method.

Example

First, declare your subclass and provide the render method:


import SurfaceDropComponent from 'jsplumbtoolkit-react';

class MyPalette extends SurfaceDropComponent {

  render() {
    return <div className="someClass">
                <ul>
                    <li data-node-type="foo" jtk-is-group="true">FOO</li>
                    <li data-node-type="bar">BAR</li>
                </ul>
           </div>
  }
}

Then create one in your app:


const typeExtractor = function(el) { return el.getAttribute("data-node-type") };
const dataGenerator = function (type) { return { w:120, h:80 }; };
const nodePaletteElement = document.querySelector(".parentOfNodePalette")

const nodePalette = ReactDOM.render(
        <MyPalette surface={this.surface} selector={"li"} container={nodePaletteElement} dataGenerator={dataGenerator}/>
, nodePaletteElement);

As with the Miniview component, this component needs a reference to a JsPlumbToolkitSurfaceComponent.

Attributes
  • selector:string A valid CSS3 selector identifying descendant nodes that are to be configured as draggable/droppables.
  • dataGenerator:(el:HTMLElement) => T This Function is used to provide default data for some Node/Group. Note that a difference between this component and the original jsplumb-palette is that your dataGenerator function is now expected to determine the "type" of the object being dragged, and to set it on the data object if desired.
  • surface Required. The JsPlumbToolkitSurfaceComponent to which to attach the Drop Manager.
  • allowDropOnGroup:boolean Optional, defaults to true. If true, then elements can be dropped onto nodes/groups, and in the event that occurs, the onDrop method will be called.
  • allowDropOnCanvas:boolean Optional, defaults to true. When an element is dropped on the canvas whitespace, it is added to the dataset and rendered.
  • allowDropOnEdge:boolean Optional, defaults to true. If true, then elements can be dropped onto edges, and in the event that an element is dropped on an edge, a new node/group is added and inserted between the source and target of the original edge, and the original edge is discarded..
  • typeGenerator:(data:T) => string Optional. A function that can return the correct type for some data object representing an element being dragged. By default the Toolkit will use the type member of the data object.
  • groupIdentifier:(d: T, el: HTMLElement) => boolean Optional. By default, the toolkit looks for a jtk-is-group attribute on an element being dragged. If found, with a value of "true", then the Toolkit assumes a group is being dragged. You can supply your own function to make this decision.

For further reading, see this page .

TOP


Each Node or Group in your UI is rendered as an individual component.

Definition

As an example, consider the component we use to render an Action node in the Flowchart builder demonstration:

import React from 'react';
import { BaseEditableComponent } from"./base-component.jsx";

/**
 * Component used to render an action node.
 */
export class ActionComponent extends BaseEditableComponent {

    constructor(props) {
        super(props)
    }

    render() {

        const obj = this.node.data;

        return <div style={{width:obj.w + 'px', height:obj.h + 'px'}} className="flowchart-object flowchart-action">
            <div style={{position:'relative'}}>
                <svg width={obj.w} height={obj.h}>
                    <rect x={10} y={10} width={obj.w-20} height={obj.h-20} className="inner"/>
                    <text textAnchor="middle" x={obj.w/2} y={obj.h/2} dominantBaseline="central">{obj.text}</text>
                </svg>
            </div>
            <div className="node-edit node-action" onClick={this.edit.bind(this)}></div>
            <div className="node-delete node-action" onClick={this.remove.bind(this)}></div>
            <div className="drag-start connect"></div>
            <jtk-target port-type="target"/>
            <jtk-source port-type="source" filter=".connect"/>
        </div>
    }
}

Here, BaseEditableComponent is common for all nodes, and offers a few basic methods like node edit/remove. The class declaration looks like this:


import { BaseNodeComponent }  from 'jsplumbtoolkit-react';
import { Dialogs } from 'jsplumbtoolkit';

export class BaseEditableComponent extends BaseNodeComponent {
    
    ...
}

Mapping to a type

Amongst other things, the view is used to map node/group types to their rendering. From 2.3.0 onwards there are two ways to map a node/group type to what gets rendered.

Here's the nodes section from the view in the original React Flowchart Builder application:

this.view = {
    nodes: {
        "start": {
           component:StartComponent
        },
        "selectable": {
            events: {
                tap:  (params) => {
                    this.toolkit.toggleSelection(params.node);
                }
            }
        },
        "question": {
            parent: "selectable",
            component:QuestionComponent
        },
        "action": {
            parent: "selectable",
            component:ActionComponent
        },
        "output":{
            parent:"selectable",
            component:OutputComponent
        }
    },
    // There are two edge types defined - 'yes' and 'no', sharing a common
    // parent.
    edges: {
        ...
    }
}

Here, we map node types to various classes. In previous versions, it was imperative that you extended BaseNodeComponent or BaseGroupComponent in the components you used to render nodes/groups. This is no longer the case, but the base components do have a few useful methods. In the React Flowchart Builder demonstration each of the components shown, as discussed above, extend BaseEditableComponent, which itself extends the Toolkit's BaseNodeComponent, and that component extends React.Component.

An alternative to mapping component classes is to provide some JSX. The view shown above actually now looks like this the demonstration code we ship:

this.view = {
    nodes: {
        "start": {
           jsx:(ctx) => { return <StartComponent ctx={ctx} /> }
        },
        "selectable": {
            events: {
                tap:  (params) => {
                    this.toolkit.toggleSelection(params.node);
                }
            }
        },
        "question": {
            parent: "selectable",
            jsx:(ctx) => { return <QuestionComponent ctx={ctx} /> }
        },
        "action": {
            parent: "selectable",
            jsx:(ctx) => { return <ActionComponent ctx={ctx} /> }
        },
        "output":{
            parent:"selectable",
            jsx:(ctx) => { return <OutputComponent ctx={ctx} /> }
        }
    },
    // There are two edge types defined - 'yes' and 'no', sharing a common
    // parent.
    edges: {
        ...
    }
}

When you use the jsx approach, you're expected to provide a function that takes ctx as argument, and returns JSX. If, as in this demonstration, your classes extend BaseNodeComponent (or BaseGroupComponent) you should pass ctx in as a prop, so that the base class can extract the things it needs to provide the various support methods it offers. If your component does not extend one of the Toolkit's base components, though, then obviously passing ctx in as a prop is entirely up to you.

ctx is an object containing five things:

interface JsxContext {
    vertex: Node | Group;           // the vertex - node or group - that is being rendered by this JSX
    surface: Surface;               // the Surface widget that is rendering the vertex
    toolkit: JsPlumbToolkit;        // the underlying JsPlumbToolkit instance
    data: Record<string, any>;      // the vertex's backing data. This is just a convenience - it can be accessed via `vertex.data`
    props: Record<string, any>;     // these are any props that you passed in as the `childProps` argument to a `JsPlumbToolkitSurfaceComponent`. See below.    
}

As mentioned above, you can pass back arbitrary JSX from these functions.

As a convenience, your components can extend BaseNodeComponent. If you use the jsx approach described above, you should pass ctx in as a prop; if you use a class reference via component, the Toolkit will take care of passing everything the base component needs.

BaseNodeComponent offers a couple of useful methods:

  • removeNode() - instructs the underlying Toolkit to remove the Node this component represents. The node will be removed from the model, and the component will be unmounted.
  • updateNode(data:Record<string, any>) - updates the underlying Node's data model. This will result in the component re-rendering.

as well as these properties:

  • node - The Node object the component is rendering
  • surface - The Surface by which the Node was rendered
  • toolkit - The underlying JsPlumbToolkit instance.

This component is conceptually identical to BaseNodeComponent, but with different method names/properties:

  • removeGroup() vs removeNode()
  • updateGroup(...) vs updateNode(...)
  • group vs node

If your UI makes use of Ports, like the Database Visualizer that ships with the Toolkit, you should extend BasePortComponent in your Port components. This is a requirement that may change in a future release. Here's how the table node type from the referenced demonstration writes out elements representing its columns:

<div className="table-columns">
    { this.node.data.columns.map(c => <ColumnComponent data={c} key={c.id} parent={this}/>) }
</div>

Each of the props shown here is required.

  • data - This is the backing data for the Port
  • key - Provide a unique key for each Port, to ensure that React only renders it once. If the Port gets re-rendered the underlying Toolkit renderer will lose the DOM element it is tracking.
  • parent - A reference to the component rendering the Vertex (Node/Group) to which the Port belongs. The BasePortComponent needs this in order to perform some essential housekeeping.

TOP


As shown in the React Skeleton demonstration, you can pass props in to the components used to render your vertices by setting them on the childProps prop of a Surface component. For instance, in the demonstration mentioned, DemoComponent - the main app - declares a random color variable in its initial state:

class DemoComponent extends React.Component {

    constructor(props) {
        super(props);
        this.toolkit = jsPlumbToolkit.newInstance();
        this.state = { color:randomColor() };
       
    }
    
}

In the render method of the DemoComponent, a surface component is created, and the color member of the main component's state is passed in:

render() {
    return <div style={{width:"100%",height:"100%",display:"flex"}}>
        <button onClick={this.changeColor.bind(this)} style={{backgroundColor:this.state.color}} className="colorButton">Change color</button>
        <JsPlumbToolkitSurfaceComponent childProps={{color:this.state.color}} renderParams={this.renderParams} toolkit={this.toolkit} view={this.view} />
    </div>
}

In the view for the DemoComponent, each of the node types references the Surface's childProps by way of the context they are given:

this.view = {
    nodes: {
        "shin":{
            jsx: (ctx) => { return <ShinBoneComponent color={ctx.props.color} ctx={ctx}/> }
        },
        "knee":{
            jsx: (ctx) => { return <KneeBoneComponent color={ctx.props.color} ctx={ctx}/> }
        }
    },
    ...
}

So, here, ctx.props.color is referencing this.state.color in DemoComponent. If we change DemoComponent's state, the change propagates through to the vertex components:

changeColor() {
    const current = this.state.color;
    let col;
    while (true) {
        col = randomColor();
        if (col !== current) {
            break;
        }
    }
    this.setState({ color:col } )
}

You may, if you're a bit React-savvy, be thinking "why not use use this.state.color as the prop for the bone components?", and that's a valid question to ask. The answer is that in this case you seem to be able to, which is good, because that's intuitive. But in other cases the exact same setup was observed to not work, which is bad, as its counter intuitive. Passing everything through the Surface as childProps, though, works in all cases.

Integrations / Angular Integration

Angular Integration

The jsPlumb Toolkit has a service and several components/directives to assist you in integrating with Angular (10.x, 9.x, 8.x, 7.x, 6.x, 5.x, 4.x and 2.x - for Angular 1.x integration, refer to this page ).

Note: Angular 8 introduced a new compiler - the Ivy compiler. The Toolkit has been tested against this compiler.


package.json

Add these lines to your package.json:

"dependencies": {
    ...
    "jsplumbtoolkit":"file:./somewhere/jsplumbtoolkit.tgz",
    "jsplumbtoolkit-angular":"file:./somewhere/jsplumbtoolkit-angular.tgz",
    
    ...
},

import { jsPlumbToolkitModule } from "jsplumbtoolkit-angular";

...

@NgModule({
    imports:      [ BrowserModule, jsPlumbToolkitModule, jsPlumbToolkitDragDropModule, ROUTING ],
    declarations: [ AppComponent, QuestionNodeComponent, ActionNodeComponent, StartNodeComponent, OutputNodeComponent, DatasetComponent, FlowchartComponent, ControlsComponent ],
    bootstrap:    [ AppComponent ],
    entryComponents: [ QuestionNodeComponent, ActionNodeComponent, StartNodeComponent, OutputNodeComponent ],
    schemas:[ CUSTOM_ELEMENTS_SCHEMA ]
})

This example comes from the Angular demonstration that ships with the Toolkit. Note that you need to import the CUSTOM_ELEMENTS_SCHEMA schema.

Component imports

To import components inside a .ts file:

import { jsPlumbSurfaceComponent, jsPlumbMiniviewComponent, jsPlumbPaletteComponent } from "jsplumbtoolkit-angular";

At the core of jsPlumb's Angular integration is the jsPlumb Service, which offers access to, and management of, Toolkit instances and Surfaces. It is recommended to create an instance of the Toolkit programmatically at the top level of your application, which you can then share between different components. For instance, this is the ngOnInit method of the top level component in the Angular demo that ships with the Toolkit:

export class AppComponent {

 @ViewChild(FlowchartComponent) flowchart:FlowchartComponent;
 @ViewChild(DatasetComponent) dataset:DatasetComponent;

 toolkitId:string;
 toolkit:jsPlumbToolkit;

 constructor(private $jsplumb:jsPlumbService) {
   this.toolkitId = "flowchart";
 }

 ngOnInit() {
   this.toolkit = this.$jsplumb.getToolkit(this.toolkitId, this.toolkitParams)
 }
 
 ...
}
 

Methods

The jsPlumb Service offers several methods. getToolkit and getSurface are the methods client applications will mostly use; unless you write your own component that renders a Surface you won't need to use the methods that add/remove Surfaces.

  • getToolkit(id:string, params?:jsPlumbToolkitOptions)

Either retrieves an existing Toolkit with the given ID, or creates a Toolkit instance and returns it. Options for the Toolkit instance may be passed in as the second argument; these are ignored if a Toolkit with the given ID already exists.

  • getSurface(id:string, callback:(surface:Surface)=>void, _params:SurfaceOptions)

Either retrieves the Surface with the given ID, or creates one, with the given Surface options, and returns it. The second argument to this method is a callback function - it is asynchronous, not returning the Surface until it has been initialised fully.

  • addSurface(id:string, surface:Surface)

Registers a Surface with the service. This method is used by the jsplumb-surface component that ships with the Toolkit.

  • removeSurface(id:string, surface:Surface)

Unregisters a Surface from the service, also calling destroy on the Surface (which calls destroy on any attached Miniviews). This method is used by the jsplumb-surface component that ships with the Toolkit.

  • addMiniview(surfaceId:string, params:MiniviewOptions)

Used by the jsplumb-miniview component.

TOP


The Toolkit offers 2 Components and 2 Directives:

This is a Component that provides a Surface widget to render the contents of some Toolkit instance.

<jsplumb-surface jtkId="toolkit" surfaceId="surfaceId" [renderParams]="anObjectReference" [view]="anObjectReference" [nodeResolver]="aFunctionReference">
</jsplumb-surface>
Attributes

All attributes are optional except nodeResolver and jtkId.

  • jtkId ID of the Toolkit instance to render.
  • surfaceId Unique ID for the Surface widget. Required if you wish to attach a Miniview or a Palette.
  • renderParams Parameters to pass in to the constructor of the Surface widget.
  • view View parameters. Views are discussed here.

TOP

This is a Component that provides a Miniview that can be attached to some Surface.

<jsplumb-miniview surfaceId="surfaceId"></jsplumb-miniview>
Attributes
  • surfaceId ID for the Surface widget to which to attach the Miniview.
  • elementFilter Optional filter used to control which nodes/groups the Miniview will display.

To use the elementFilter you need to provide a reference to a Function, whose method signature is

(obj: Node|Group) => boolean;

For instance,

<jsplumb-miniview [surfaceId]="surfaceId" [elementFilter]="redNodeFilter"></jsplumb-miniview>

Then in your code you might have :

    redNodeFilter(obj: Node | Group): boolean {
      return obj.objectType === "Node" && obj.data.type === "red";
    }

Here, only Nodes that have a type of red will be shown in the miniview.

Methods

The Miniview component offers a method to repaint itself:

redraw()

This will invalidate the miniview, reposition all the elements it is managing, and zoom everything to fit the miniview's viewport.

TOP

This Directive wraps an instance of the Drop Manager, and is an improvement over the previous jsplumb-palette in a few ways:

  • it uses a delegated drag handler so you do not need to inform it when its child content has been updated
  • the component can be enabled/disabled
  • it supports dropping nodes onto edges
Setup

You need to include a couple of extra things to access this component:

"jsplumbtoolkit-drop": "file:../../jsplumbtoolkit-drop.tgz",
"jsplumbtoolkit-angular-drop": "file:../../jsplumbtoolkit-angular-drop.tgz"

And you also need to import and then reference the jsPlumbToolkitDragDropModule:


...
import { jsPlumbToolkitDragDropModule } from "jsplumbtoolkit-angular-drop";
...

@NgModule({
    ...
    imports:[ ..., jsPlumbToolkitDragDropModule, ...],
    ...
    
})
Example

This comes from the Angular Flowchart Builder demonstration:

<div class="sidebar node-palette" 
     jsplumb-surface-drop 
     selector="div" 
     surfaceId="flowchartSurface" 
     [dataGenerator]="dataGenerator">
  <div *ngFor="let nodeType of nodeTypes" class="sidebar-item" [attr.data-node-type]="nodeType.type" title="Drag to add new" [attr.jtk-width]="nodeType.w" [attr.jtk-height]="nodeType.h">{{nodeType.label}}</div>
</div>
Attributes
  • selector:string A valid CSS3 selector identifying descendant nodes that are to be configured as draggable/droppables.
  • dataGenerator:(el:HTMLElement) => T This Function is used to provide default data for some Node/Group. Your dataGenerator function is expected to determine the "type" of the object being dragged, and to set it on the data object if desired.
  • surfaceId Required. The ID of the Surface to which to attach the Drop Manager.
  • allowDropOnGroup:boolean Optional, defaults to true. If true, then elements can be dropped onto nodes/groups, and in the event that occurs, the onDrop method will be called.
  • allowDropOnCanvas:boolean Optional, defaults to true. When an element is dropped on the canvas whitespace, it is added to the dataset and rendered.
  • allowDropOnEdge:boolean Optional, defaults to true. If true, then elements can be dropped onto edges, and in the event that an element is dropped on an edge, a new node/group is added and inserted between the source and target of the original edge, and the original edge is discarded..
  • typeGenerator:(data:T) => string Optional. A function that can return the correct type for some data object representing an element being dragged. By default the Toolkit will use the type member of the data object.
  • groupIdentifier:(d: T, el: HTMLElement) => boolean Optional. By default, the toolkit looks for a jtk-is-group attribute on an element being dragged. If found, with a value of "true", then the Toolkit assumes a group is being dragged. You can supply your own function to make this decision.

TOP


NOTE Unless you need to respond to a drop on a node, the Surface Drop Manager provides a more simple way of configuring drag/drop of new items. This section is still valid, but it's not the fastest way of adding the functionality.

This Directive wraps an instance of the Drop Manager, and is an improvement over the previous jsplumb-palette in a few ways:

  • it uses a delegated drag handler so you do not need to inform it when its child content has been updated
  • the component can be enabled/disabled
  • it supports dropping nodes onto edges
Setup

You need to include a couple of extra things to access this component:

"jsplumbtoolkit-drop": "file:../../jsplumbtoolkit-drop.tgz",
"jsplumbtoolkit-angular-drop": "file:../../jsplumbtoolkit-angular-drop.tgz"

And you also need to import and then reference the jsPlumbToolkitDragDropModule:


...
import { jsPlumbToolkitDragDropModule } from "jsplumbtoolkit-angular-drop";
...

@NgModule({
    ...
    imports:[ ..., jsPlumbToolkitDragDropModule, ...],
    ...
    
})
Example

This comes from a previous version of the Angular Flowchart Builder demonstration, which now uses the Surface Drop Manager:

<div class="sidebar node-palette" 
     jsplumb-drag-drop 
     selector="div" 
     surfaceId="flowchartSurface" 
     [dataGenerator]="dataGenerator"
     [onCanvasDrop]="onCanvasDrop"
     [onEdgeDrop]="onEdgeDrop">
  <div *ngFor="let nodeType of nodeTypes" class="sidebar-item" [attr.data-node-type]="nodeType.type" title="Drag to add new" [attr.jtk-width]="nodeType.w" [attr.jtk-height]="nodeType.h">{{nodeType.label}}</div>
</div>
Attributes
  • selector A valid CSS3 selector identifying descendant nodes that are to be configured as draggable/droppables.
  • surfaceId The ID of the Surface to which to attach the Palette.
  • dataGenerator(el:HTMLElement):T This optional Function can be used to provide default data for some Node/Group. Your dataGenerator function is expected to determine the "type" of the object being dragged, and to set it on the data object if desired.
  • onCanvasDrop(surface:Surface, data:T, positionOnSurface:CanvasLocation):void Optional. When present, drop on whitespace is enabled. Dropping an object on whitespace will result in this method being called.
  • onEdgeDrop(surface:Surface, data:T, edge:Edge, positionOnSurface:CanvasLocation) Optional. When present, drop on edges is enabled. Dropping an object on an edge will result in this method being called.
  • onDrop(data:T, target:Node|Group, draggedElement?:HTMLElement, e?:Event, position?:PointArray) Optional. When present, drop on nodes/groups is enabled, and dropping an object on a node/group will result in this method being called.

TOP


Each Node or Group in your UI is rendered as an individual component. These component definitions need to be included in the declarations and entryComponents members of your application's module definition.

Definition

As an example, consider the component we use to render an Action node in the Flowchart builder demonstration:

@Component({ templateUrl:"templates/action.html" })
export class ActionNodeComponent extends BaseEditableNodeComponent  { }

Here, BaseEditableNodeComponent is a class that declares a couple of common editing methods for that specific demonstration. But there is a key piece in the declaration of BaseEditableNodeComponent that you must take into account:

class BaseEditableNodeComponent extends BaseNodeComponent {

}

... the fact that it extends BaseNodeComponent. Your components must extend BaseNodeComponent.

Template

The component definition maps a templateUrl. This is what the template looks like in this example:

<div [style.width]="obj.w + 'px'" [style.height]="obj.h +'px'" class="flowchart-object flowchart-action">
    <div>
        <div class="node-edit node-action" (click)="editNode(obj)">
            <i class="fa fa-pencil-square-o"></i>
        </div>
        <div class="node-delete node-action" (click)="removeNode(obj)">
            <i class="fa fa-times"></i>
        </div>
        <svg [attr.width]="obj.w" [attr.height]="obj.h">
            <rect [attr.x]="0" [attr.y]="0" [attr.width]="obj.w" [attr.height]="obj.h" class="outer"/>
            <rect [attr.x]="10" [attr.y]="10" [attr.width]="obj.w-20" [attr.height]="obj.h-20" class="inner"/>
            <text text-anchor="middle" [attr.x]="obj.w/2" [attr.y]="obj.h/2" dominant-baseline="central">{{obj.text}}</text>
        </svg>
    </div>
    <jtk-target port-type="target"></jtk-target>
    <jtk-source port-type="source" filter=".outer"></jtk-source>
</div>

It's a standard Angular template. The main thing to be aware of here is that the backing data for the Node or Group is presented as the member obj to the template. You don't, of course, need to use the templateUrl approach - you can provision the template in any way that Angular supports, including directly as a multi-line string via the template parameter.

Mapping to a type

You map components to node/group types in the view. Here's the nodes section from the view in the Angular Flowchart Builder application:

view = {
    nodes:{
      "start":{
        component:StartNodeComponent
      },
      "selectable": {
        events: {
          tap: (params:any) => {
            this.toggleSelection(params.node);
          }
        }
      },
      "question":{
        parent:"selectable",
        component:QuestionNodeComponent
      },
      "output":{
        parent:"selectable",
        component:OutputNodeComponent
      },
      "action":{
        parent:"selectable",
        component:ActionNodeComponent
      }
    },
    edges: {
    
    ...
    }
}

In previous versions of the Toolkit's Angular integration it was necessary to map component names to actual components via a nodeResolver function, but from 1.11.0 this is no longer necessary.

Declaration

You must declare each Node/Group component in both the declarations and entryComponents members of your module definition. Here's the module definition for the Flowchart builder demonstration, for example:

import { jsPlumbToolkitModule } from "jsplumbtoolkit-angular";

...

@NgModule({
    imports:      [ BrowserModule, jsPlumbToolkitModule, jsPlumbToolkitDragDropModule, ROUTING ],
    declarations: [ AppComponent, QuestionNodeComponent, ActionNodeComponent, StartNodeComponent, OutputNodeComponent, DatasetComponent, FlowchartComponent, ControlsComponent ],
    bootstrap:    [ AppComponent ],
    entryComponents: [ QuestionNodeComponent, ActionNodeComponent, StartNodeComponent, OutputNodeComponent ],
    schemas:[ CUSTOM_ELEMENTS_SCHEMA ]
})

Checklist

  • Each of your components extends BaseNodeComponent from the Toolkit's Angular integration
  • You reference the underlying data via the member obj in your component templates
  • Each of your components is declared in the declarations list in your module definition
  • Each of your components is declared in the entryComponents list in your module definition
  • You've mapped each expected node/group type to a component in your view

TOP


Some applications whose data model use ports have a UI in which each Port is assigned its own DOM element. In the Flowchart Builder application we use ports in the data model (a question node, for instance, has a Yes and a No output port), but we do not assign a DOM element to each port. In the Database Visualizer, though, we do: we model a database table as a node, and the columns on that table as ports, and each port is assigned its own DOM element:

Database Visualizer Table Node

Here we see three columns, each of which has a button by which it can be deleted, and a button that launches a column name editor. These two bits of behaviour are handled by the component backing the port.

Definition

This is the definition of the component used to render columns on table nodes:


import { BasePortComponent } from "jsplumbtoolkit-angular";

@Component({
  selector:"db-column",
  templateUrl:"templates/column.html"
})
export class ColumnComponent extends BasePortComponent {

  constructor(el: ElementRef) {
    super(el);
  }
  
  remove() { ... }
  
  editName() { ... }
}

There are three requirements for a component to be used to render a port:

  • you must extend BasePortComponent
  • your constructor must accept an ElementRef and call the superclass constructor with it
  • you must declare a selector for the component

Template

The component definition maps a templateUrl. This is what the template looks like in this example:

<li class="table-column table-column-type-{{obj.datatype}}" data-primary-key="obj.primaryKey" data-port-id="obj.id">
  <div class="table-column-edit" (click)="editName()">
    <i class="fa fa-pencil table-column-edit-icon"></i>
  </div>
  <div class="table-column-delete" (click)="remove()">
    <i class="fa fa-times table-column-delete-icon"></i>
  </div>
  <div><span>{{obj.id}}</span></div>
  <!--
      configure the li as an edge source, with a type of column, a scope derived from
      the columns datatype, and a filter that prevents dragging new edges from the delete button or from the label.
  -->
  <jtk-source port-id="{{obj.id}}" scope="{{obj.datatype}}" filter=".table-column-delete, .table-column-delete-icon, span, .table-column-edit, .table-column-edit-icon" filter-exclude="true"></jtk-source>
  <!--
      configure the li as an edge target, with a type of column, and a scope derived from the
      column's datatype.
  -->
  <jtk-target port-id="{{obj.id}}" scope="{{obj.datatype}}"></jtk-target>
</li>

Mapping to a type

You map components to port types in the view. Here's the ports section from the view in the Angular Database Visualizer application:

ports: {
  "default": {
    component: ColumnComponent,
    paintStyle: { fill: "#f76258" },        // the endpoint's appearance
    hoverPaintStyle: { fill: "#434343" }, // appearance when mouse hovering on endpoint or connection
    edgeType: "common", // the type of edge for connections from this port type
    maxConnections: -1, // no limit on connections
    dropOptions: {  //drop options for the port. here we attach a css class.
      hoverClass: "drop-hover"
    },
    events: {
      "dblclick": (p:any) => {
        console.log(p);
      }
    }
  }
}

Declaration

You must declare each port component in both the declarations and entryComponents members of your module definition. Here's the module definition for the Database Visualizer demonstration, for example:


import { DatabaseVisualizerComponent, TableNodeComponent, ViewNodeComponent, ColumnComponent } from './database-visualizer';

...

@NgModule({
    imports:[ BrowserModule, jsPlumbToolkitModule, jsPlumbToolkitDragDropModule, ROUTING],
    declarations: [ AppComponent, TableNodeComponent, ViewNodeComponent, ColumnComponent, DatasetComponent, DatabaseVisualizerComponent ],
    bootstrap:    [ AppComponent ],
    entryComponents: [ TableNodeComponent, ColumnComponent, ViewNodeComponent ],
    schemas:[ CUSTOM_ELEMENTS_SCHEMA ]
})

...

Here we see ColumnComponent listed in both declarations and entryComponents (along with the components used to render the node types table and view).

Checklist

  • Each of your port components extends BasePortComponent from the Toolkit's Angular integration
  • You reference the underlying data via the member obj in your component templates
  • Each of your components is declared in the declarations list in your module definition
  • Each of your components is declared in the entryComponents list in your module definition
  • You've mapped each expected port to a component in your view

TOP


This is a rough guide to integrating the Toolkit into an existing Angular application.

1. Copy the toolkit imports (toolkit + toolkit angular) from the Angular demo into your package.json, and get them installed.
"dependencies":{

  ...
  "jsplumbtoolkit":"file:path/to/jsplumbtoolkit.tgz",
  "jsplumbtoolkit-angular":"file:path/to/jsplumbtoolkit-angular.tgz",
  ...
}  
2. Import the jsplumbtoolkit-defaults.css file into your CSS. This provides some sane defaults.

The default in an Angular CLI app is to use the styles.css file to orchestrate your css. We import it like this in our demo pages:

@import "jsplumbtoolkit-defaults.css";
3. Figure out where in your app you want to create an instance of the Toolkit.

You create instances of the Toolkit via the jsPlumb service. For instance, in our Angular demo, we do this in the ngInit method of our AppComponent (the main component in the demo), after injecting the service:

export class AppComponent {

  @ViewChild(FlowchartComponent) flowchart:FlowchartComponent;
  @ViewChild(DatasetComponent) dataset:DatasetComponent;

  toolkitId:string;
  toolkit:jsPlumbToolkit;

  constructor(private $jsplumb:jsPlumbService, private elementRef:ElementRef) {
    this.toolkitId = this.elementRef.nativeElement.getAttribute("toolkitId");
  }

  ngOnInit() {
    this.toolkit = this.$jsplumb.getToolkit(this.toolkitId, this.toolkitParams)
  }

...
}

Note here that we read toolkitId from the DOM element but you could fix that to some string. You'll need this Toolkit ID when you configure your Surface element below.

4. Create an empty component - and its template - that extends BaseNodeComponent:
@Component({ templateUrl:"templates/simple.html" })
export class SimpleNodeComponent extends BaseNodeComponent { }

This is about as simple a component as you can make; it has no code in it at all. But it is important that it extends BaseNodeComponent (which is part of the Toolkit's Angular integration).

Here's a basic template you could use (this would be in the file ./templates/simple.html according to the component declaration above):

<div style="width:100px;height:50px;outline:1px solid;">
  <h3>{{ obj.name }}</h3>
</div>

Note the underlying data is presented to an Angular template as obj. This is always the case.

5. Add the jsplumb-surface element to some component...
<jsplumb-surface [surfaceId]="surfaceId" [toolkitId]="toolkitId" [view]="view" [renderParams]="renderParams"></jsplumb-surface>

...and in the component provide a few things:


...


view = {
  nodes:{
    default:{
      component:SimpleNodeComponent
    }
  }
}

renderParams = {
  layout:{
    type:"Spring"
  }
}
  • view is the declarative mapping of definitions to rendering and behaviour, discussed in our documentation. This is a very simple view - it just maps a renderer for all node types.

  • renderParams are the parameters ultimately passed to the render call on the underlying Toolkit instance. These are the parameters for the Surface widget. Here we just set a layout, but there’s a lot you can do with this.

6. Once you have done these steps, you should be able to load some data:
toolkit.load({
  nodes:[ {id:"1", name:"one"}, {id:"2", name:"two"}],
  edges:[ {source:"1", target:"2" } ]
})

Further Reading

Demonstrations for the jsPlumb Toolkit are available on Github. There are 3 that use the Angular integration, each of which is documented:

TOP


All versions of Angular from 2 through 10 are supported. Our demonstration pages all use Angular 9, but the Toolkit has also been tested against 10.x, 8.x, 7.x, 6.x, 5.x and 2.x.

TOP

- Imports
- Setup
- Bootstrap
- Imports
- jsPlumbToolkitVue2 module
- Components
- jsplumb-toolkit
- jsplumb-miniview
- SurfaceDrop mixin
- BaseNodeComponent
- BaseGroupComponent
- Rendering Nodes and Groups
- Rendering Ports
- DragDrop Mixin
- Inserting a node between two existing nodes on drop
Vue 2 Integration
The jsPlumb Toolkit has several components to assist you in integrating with Vue 2 in dist/jsplumbtoolkit-vue2.tgz.
You may also like to read the documentation for the Vue2 Flowchart Builder demonstration
You need to include the jsPlumb Toolkit and the jsPlumb Toolkit Vue 2 adapter. Since the Toolkit edition is not open source, if you need to include it as an import in package.json, you can use (from NPM 3+) a local import:
ES6 Module
"dependencies": {
...
"jsplumbtoolkit":"file:./somewhere/jsplumbtoolkit.tgz",
"jsplumbtoolkit-vue2":"file:./somewhere/jsplumbtoolkit-vue2.tgz"
...
},From 2.1.0 the Vue2 components are shipped with precompiled templates, meaning you need to import the Toolkit in your Vue bootstrap code. For instance, this is the bootstrap routine from the Vue Flowchart demo that ships with the Toolkit:
import Vue from 'vue'
import App from './App.vue'
import { JsPlumbToolkitVue2Plugin } from 'jsplumbtoolkit-vue2'; // <---- import the Toolkit Vue 2 plugin
Vue.config.productionTip = false
require('@/assets/css/jsplumbtoolkit.css');
require('@/assets/css/jsplumbtoolkit-demo-support.css');
require('@/assets/css/jsplumbtoolkit-editable-connectors.css');
require('@/assets/css/app.css');
Vue.use(JsPlumbToolkitVue2Plugin); // <-- instruct Vue to load the Toolkit plugin
new Vue({ render: h => h(App) }).$mount('#app')
The jsPlumbToolkitVue2 module coordinates the various Vue components offered by the Toolkit
Most of the integration work between the Toolkit and Vue is taken care of by the components the Toolkit offers (discussions of which follow below) via interaction with "private" methods on the jsPlumbToolkitVue2 module. There is one public method on the module that you may find yourself using, though:
- getSurface(id:string, callback:(s:Surface)=>any):void
Retrieves the surface with the given ID. We will update this to return a Promise at some stage. It is asynchronous because it is feasible that a call could be made to this method prior to the Surface having been created.
The Toolkit offers 2 components and 3 mixins:
This component provides an instance of the Toolkit and a Surface widget to render the contents.
Example
<jsplumb-toolkit id="toolkit" surface-id="surfaceId" v-bind:render-params="anObjectReference"
v-bind:toolkit-params="anObjectReference" v-bind:view="anObjectReference">
</jsplumb-toolkit>Attributes
All attributes are optional. Note that Vue prefers "kebab case" for attribute names, even if the actual property is camel case on the component (and of course Javascript does not like kebab case for property names).
idUnique ID for the Toolkit instance. Can be used to retrieve a Toolkit instance from the jsPlumbToolkitVue2 module.surface-idUnique ID for the Surface widget. Required if you wish to attach a Miniview or a Palette. Also useful if you wish to interact with a Surface, to perform operations such as zooming, centering on content, etc.render-paramsParameters to pass in to the constructor of the Surface widget. Note here we use thev-bind:prefix to tell Vue that the object we are injecting is in the Vue instance's model.toolkit-paramsParameters to pass in to the constructor of the Toolkit instance. Note again the use ofv-bind:in our example above.viewView parameters. Views are discussed here.
This is a component that provides a Miniview that can be attached to some Surface.
Example
Attributes
surface-idID for the Surface widget to which to attach the Miniview.
This mixin is a wrapper around the Drop Manager, which offers the ability to drop onto edges, nodes and the canvas itself
Installation
This mixin is supplied in a separate package, as it has a dependency on the Toolkit's underlying Drop Manager.
"devDependencies":{
...
"jsplumbtoolkit-drop":"file:./somewhere/jsplumbtoolkit-drop.tgz",
"jsplumbtoolkit-vue2-drop":"file:./somewhere/jsplumbtoolkit-vue2-drop.tgz"
}Example
This is an example of a component that uses the SurfaceDrop mixin. We show, in the onCanvasDrop method, an example of how this mixin can be used to replace the previous Palette mixin. Note, though, the onEdgeDrop and onDrop methods: these are, respectively, called when an element is dragged on an Edge or a Node/Group.
<template>
<div class="sidebar node-palette">
<div class="sidebar-item" :data-node-type="entry.type" title="Drag to add new" v-for="entry in data" :key="entry.type">
<i :class="entry.icon"></i>{{entry.label}}
</div>
</div>
</template>
<script>
import { SurfaceDrop } from 'jsplumbtoolkit-vue2-drop';
export default {
mixins:[ SurfaceDrop ],
data:function() {
return {
data:[
{ icon:"icon-tablet", label:"Question", type:"question" },
{ icon:"icon-eye-open", label:"Action", type:"action" },
{ type:"output", icon:"icon-eye-open", label:"Output" }
]
};
}
}
</script>Note that this component itself doesn't declare any props, and you are free to provide any template you wish to render the component's data. The underlying DragDrop mixin's props are:
- surfaceId:string Required. The ID of the Surface to which to attach the Drop Manager.
- selector:string Required. A CSS3 selector instructing the Toolkit how to identify which elements in the component represent draggable node types.
- dataGenerator:(el:HTMLElement) => T Optional. A function that can return a data object representing an element which is being dragged. This function is called as soon as an element starts to be dragged.
- allowDropOnGroup:boolean Optional, defaults to true. If true, then elements can be dropped onto nodes/groups, and in the event that occurs, the
onDropmethod will be called. - allowDropOnCanvas:boolean Optional, defaults to true. When an element is dropped on the canvas whitespace, it is added to the dataset and rendered.
- allowDropOnEdge:boolean Optional, defaults to true. If true, then elements can be dropped onto edges, and in the event that an element is dropped on an edge, a new node/group is added and inserted between the source and target of the original edge, and the original edge is discarded..
- typeGenerator:(data:T) => string Optional. A function that can return the correct type for some data object representing an element being dragged. By default the Toolkit will use the
typemember of the data object. - groupIdentifier:(d: T, el: HTMLElement) => boolean Optional. By default, the toolkit looks for a
jtk-is-groupattribute on an element being dragged. If found, with a value of"true", then the Toolkit assumes a group is being dragged. You can supply your own function to make this decision.
This mixin should be included in any component you will use to render a node (see below for discussion of this). Several helper methods are exposed by this mixin:
- getNode() Gets the underlying Toolkit node that the component is rendering
- removeNode() Instructs the Toolkit to remove the node that the component is rendering. This will of course result in the destruction of the component.
- getToolkit() Gets the underlying Toolkit instance for the node the component is rendering.
- updateNode(data:any) Updates the underlying node that the component is rendering.
Nodes rendered with this mixin are fully reactive: calls to updateNode will result in a repaint of the component with no further effort involved on your part.
This mixin should be included in any component you will use to render a group (see below for discussion of this). Several helper methods are exposed by this mixin:
- getGroup() Gets the underlying Toolkit group that the component is rendering
- removeGroup(removeChildNodes?:boolean) Instructs the Toolkit to remove the group that the component is rendering, and possibly all of the child nodes of the group too. This will of course result in the destruction of the component.
- getToolkit() Gets the underlying Toolkit instance for the group the component is rendering.
- updateGroup(data:any) Updates the underlying group that the component is rendering.
Groups rendered with this mixin are fully reactive: calls to updateGroup will result in a repaint of the component with no further effort involved on your part.
To render nodes and groups you have two options:
- use the Toolkit's default template renderer, Knockle
- use a Vue component for each node/group type
Using a Vue component is of course far more appealing, and we'll discuss that first. It's pretty straightforward: you create a component, import it into the code that's handling your Toolkit instance, and then map it via the view. Imagine you make this component inside MyNode.vue:
<template>
<div>
<h1>{{obj.label}}</h1>
<button v-on:click="clicked()">CLICK ME</button>
</div>
</template>
<script>
import { BaseNodeComponent } from "jsplumbtoolkitvue2";
export default {
mixins:[ BaseNodeComponent ],
methods:{
clicked:function() {
alert(this.getNode().data.label);
}
}
}
</script>
And you make this component, to manage an instance of the Toolkit:
<template>
<jsplumb-toolkit
ref="toolkitComponent"
url="flowchart-1.json"
v-bind:render-params="renderParams"
v-bind:view="view"
id="toolkit"
surface-id="surface"
v-bind:toolkit-params="toolkitParams">
</jsplumb-toolkit>
</template>
<script>
import MyNode from './MyNode.vue';
export default {
name: 'jsp-toolkit',
props:["surfaceId"],
data:() => {
renderParams:{ ... },
view:{
nodes:{
default:{
component:MyNode
}
}
}
}
}
</script>MyNode is mapped to the component used to render nodes of type "default" (which for the Toolkit means any node). The jsplumb-toolkit declaration in the template is the one from the [demo-vue2](Vue2 Flowchart Demonstration), which is a good place to look to get a feel for how a whole application can be built using the Toolkit.
The Angular and React integrations that ship with the Toolkit offer specific support for rendering ports as well as node and groups. The initial release of the Toolkit's upgraded Vue integration does not yet offer this, but we're working on it for our next release. This functionality is of specific use if you are building an application like the [demo-angular-database-visualiser](Database Visualiser).
NOTE Unless you need to respond to a drop on a node, the Surface Drop Manager provides a more simple way of configuring drag/drop of new items. This section is still valid, but it's not the fastest way of adding the functionality.
This mixin is a wrapper around the Drop Manager, which offers the ability to drop onto edges, nodes and the canvas itself, and is a replacement for the original Palette mechanism. The Palette still exists, as does its Vue wrapper, but will be deprecated in an upcoming release and then eventually removed.
Installation
This mixin is supplied in a separate package, as it has a dependency on the Toolkit's underlying Drop Manager.
"devDependencies":{
...
"jsplumbtoolkit-drop":"file:./somewhere/jsplumbtoolkit-drop.tgz",
"jsplumbtoolkit-vue2-drop":"file:./somewhere/jsplumbtoolkit-vue2-drop.tgz"
}Example
This is an example of a component that uses the DragDrop mixin. We show, in the onCanvasDrop method, an example of how this mixin can be used to replace the previous Palette mixin. Note, though, the onEdgeDrop and onDrop methods: these are, respectively, called when an element is dragged on an Edge or a Node/Group.
<template>
<div class="sidebar node-palette">
<div class="sidebar-item" :data-node-type="entry.type" title="Drag to add new" v-for="entry in data" :key="entry.type">
<i :class="entry.icon"></i>{{entry.label}}
</div>
</div>
</template>
<script>
import { DragDrop } from 'jsplumbtoolkit-vue2-drop';
export default {
mixins:[ DragDrop ],
data:function() {
return {
data:[
{ icon:"icon-tablet", label:"Question", type:"question" },
{ icon:"icon-eye-open", label:"Action", type:"action" },
{ type:"output", icon:"icon-eye-open", label:"Output" }
]
};
},
methods:{
onCanvasDrop:function(surface:Surface, data:any, positionOnSurface:[number, number]) {
surface.getToolkit().addFactoryNode(data.type, {
left:positionOnSurface.left,
top:positionOnSurface.top,
foo:data.foo
});
},
onEdgeDrop:function(surface:Surface, data:any, edge:Edge,
positionOnSurface:[number, number],
draggedElement:HTMLElement, evt:Event,
pageLocation:{left:number, top:number}) {
...
},
onDrop:function(surface:Surface, data:any, target:Node|Group,
positionOnSurface:[number, number],
draggedElement:HTMLElement,
event:Event) {
...
}
}
}
</script>Note that this component itself doesn't declare any props, and you are free to provide any template you wish to render the component's data. The underlying DragDrop mixin's props are:
- surfaceId Required. The ID of the Surface to which to attach the Drop Manager.
- selector Required. A CSS3 selector instructing the Toolkit how to identify which elements in the component represent draggable node types.
- dataGenerator Optional. A function that can return a data object representing an element which is being dragged. This function is called as soon as an element starts to be dragged.
- allowDropOnNodesAndGroups Optional, defaults to false. If true, then elements can be dropped onto nodes/groups, and in the event that occurs, the
onDropmethod will be called. - allowDropOnCanvas Optional, defaults to true, which mimics the behaviour of the original Palette. When an element is dropped on the canvas whitespace, the
onCanvasDropmethod will be called. - allowDropOnEdges Optional, defaults to false. If true, then elements can be dropped onto edges, and in the event that occurs, the
onEdgeDropmethod will be called.
Each of the methods shown are optional, but you will of course want to provide an implementation of at least one of them:
- onCanvasDrop Called when an element is dropped on the canvas whitespace.
- onEdgeDrop Called when an element is dropped on an edge.
- onDrop Called when an element is dropped on a node or group.
This is a use case we are asked about fairly regularly. A discussion of this can be found in the Drop Manager documentation.